let queen = "♛"
let white_bg = "\x1b[107m"
let black_bg = "\x1b[40m"
let reset = "\x1b[0m"
let red_fg = "\x1b[91m"


let print_board board =
  Array.iteri (fun i row ->
      Array.iteri (fun j b ->
          Printf.printf "%s" (if i mod 2 = j mod 2 then white_bg else black_bg);
          if b then Printf.printf "%s%s " red_fg queen else Printf.printf "  ";
          Printf.printf "%s" reset) row;
      Printf.printf "\n"
    ) board;
  Printf.printf "--\n%!" (* %! flush le buffer et force l'affichage *)


(* 1.5 *)
let print_list queens n =
  for i = 0 to n - 1 do
    for j = 0 to n - 1 do
      Printf.printf "%s" (if i mod 2 = j mod 2 then white_bg else black_bg);
      if List.mem (i,j) queens then
        Printf.printf "%s%s " red_fg queen
      else
        Printf.printf "  ";
      Printf.printf "%s" reset;
    done;
    Printf.printf "\n";
  done;
  Printf.printf "--\n%!"